
package cn.orionsec.ops.handler.importer.impl;

import cn.orionsec.kit.lang.utils.io.Files1;
import cn.orionsec.kit.spring.SpringHolder;
import cn.orionsec.ops.constant.app.RepositoryStatus;
import cn.orionsec.ops.dao.ApplicationRepositoryDAO;
import cn.orionsec.ops.entity.domain.ApplicationRepositoryDO;
import cn.orionsec.ops.entity.importer.DataImportDTO;
import cn.orionsec.ops.utils.Utils;

import java.io.File;


public class AppRepositoryDataImporter extends AbstractDataImporter<ApplicationRepositoryDO> {

    private static final ApplicationRepositoryDAO applicationRepositoryDAO = SpringHolder.getBean(ApplicationRepositoryDAO.class);

    public AppRepositoryDataImporter(DataImportDTO importData) {
        super(importData, applicationRepositoryDAO);
    }

    @Override
    protected void insertFiller(ApplicationRepositoryDO row) {
        row.setRepoStatus(RepositoryStatus.UNINITIALIZED.getStatus());
    }

    @Override
    protected void updateFiller(ApplicationRepositoryDO row) {
        Long id = row.getId();
        ApplicationRepositoryDO beforeRepo = applicationRepositoryDAO.selectById(id);
        if (beforeRepo != null && !beforeRepo.getRepoUrl().equals(row.getRepoUrl())) {
            // 如果修改了url则状态改为未初始化
            row.setRepoStatus(RepositoryStatus.UNINITIALIZED.getStatus());
            // 删除 event 目录
            File clonePath = new File(Utils.getRepositoryEventDir(id));
            Files1.delete(clonePath);
        }
    }

}
